﻿@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization

@inject PrioridadAgent prioridadAgent
@inject SlaAgent slaAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnUpdate=@UpdateItem OnDelete=@DeleteItem OnCreate=@CreateItem>
    <GridToolBar>
        <GridCommandButton Command="Add" Icon="add">Agregar Prioridad</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(PrioridadDto.Nombre) Editable="true" />
        <GridColumn Field=@nameof(PrioridadDto.CreadoPor) Editable="false" Title="Creado Por" />
        <GridColumn Field=@nameof(PrioridadDto.SlaId) Editable="true" Title="Sla">
            <Template>
                @{
                    int slaId = (context as PrioridadDto).SlaId;
                    <text>@slas.Where(b => b.Id == slaId).FirstOrDefault().Descripcion</text>
                }
            </Template>
            <EditorTemplate>
                @{
                    PrioridadDto prioridad = context as PrioridadDto;
                }
                <div class="k-form-field">
                    <div class="k-form-field-wrap">
                        <TelerikComboBox Data="@slas" Placeholder="Selecciona el SLA" @bind-Value="@prioridad.SlaId"
                                         TextField="@nameof(SlaDto.Descripcion)" ValueField="@nameof(SlaDto.Id)" Filterable="true" Width="100%">
                        </TelerikComboBox>
                    </div>
                </div>
            </EditorTemplate>
        </GridColumn>
        <GridColumn Field=@nameof(PuestoDto.FechaRegistro) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Registro" />
        <GridColumn Field=@nameof(PuestoDto.ModificadoPor) Editable="false" Title="Modificado Por" />
        <GridColumn Field=@nameof(PuestoDto.FechaRegistro) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Modificación" />
        <GridCommandColumn Width="120px">
            <GridCommandButton Command="Edit" Icon="edit"></GridCommandButton>
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    public List<PrioridadDto> GridData { get; set; } = new List<PrioridadDto>();

    public List<SlaDto> slas { get; set; } = new List<SlaDto>();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        try
        {
            GridData = await prioridadAgent.Get();
            slas = await slaAgent.Get();
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void CreateItem(GridCommandEventArgs args)
    {
        try
        {
            PrioridadDto prioridad = args.Item as PrioridadDto;
            prioridad.Borrado = false;
            prioridad.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            prioridad.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await prioridadAgent.Add(prioridad);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        PuestoDto puesto = args.Item as PuestoDto;
        try
        {
            if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
            {

            }
            await prioridadAgent.Remove(puesto.Id);
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
        StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        try
        {
            PrioridadDto prioridad = args.Item as PrioridadDto;
            prioridad.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await prioridadAgent.Edit(prioridad);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }
}